//#######################################
//##                                   ##
//## Title:   JavaScript Code Stripper ##
//## Author:  Kristian Zarse           ##
//##          Kristian.Zarse at web.de ##
//## Version: 1.5.0.2                  ##
//## Date:    01.05.2006   1.5.0.1     ##
//## Update:  26.09.2006   1.5.0.2     ##
//##                                   ##
//#######################################

var Version = 'V1.5.0.2';

//==========================================================================================

/*
function test()
{
	alert('test');
} //test
*/

//==========================================================================================

	
function DeleteEmptyRows()
{	var s = F1.txtOut.value;
	s = s.replace(/^\s+|\s+$/g, '');
	s = s.replace(/\r\n/g, "\n");
	s = s.replace(/\r/g, "\n");
	while (s.indexOf("\n\n") >= 0) { s = s.replace(/\n\n/g, "\n"); }
	F1.txtOut.value = s;
} //DeleteEmptyRows


//==========================================================================================


function JoinRows() { F1.txtOut.value = F1.txtOut.value.replace(/\r|\n/g, ''); }


//==========================================================================================


function ThousandsDots(num)
{	num = num + ''; //conversion to string in order to make "length" working correctly
	var i = 0;
	var d = 0;
	var out = '';
	for (i=num.length-1; i>=0; i--)
	{	if (d == 3) { out = '.' + out; d = 0; }	//would also be possible with % (modulo 4) somehow
		out = num.charAt(i) + out;
		d++;
	} //for
	return(out);
} //ThousandsDots


//==========================================================================================

function CalcBytes()
{
	var Li = F1.txtIn.value.length;
	var Lo = F1.txtOut.value.length;
	F1.bytIn.value=ThousandsDots(Li);
	F1.bytOut.value=ThousandsDots(Lo);
	if (Li > 0)
	{	F1.bytPercent.value = Math.round(100*(1-(Lo/Li))) + '%'; } else
	{	F1.bytPercent.value = '-'; }
} //CalcBytes
	

//==========================================================================================


function SearchReplace()
{	var sr = F1.txtSR.value.replace(/^\s+|\s+$/g, '');
	if (sr == '') { return; }
	sr = sr.replace(/\r\n/g, "\n");
	sr = sr.replace(/\r/g, "\n");
	
	
	var arr = sr.split("\n"); sr = '';
	var i = 0;
	
	for(i=0; i<arr.length; i++) { arr[i] = arr[i].split("\t"); }
	
	i = 0; var booOkay = true;
	while (booOkay && i<arr.length) { booOkay = (arr[i].length == 2); i++; }
	if (booOkay == false) { alert('Row ' + i + ' does not contain a tab separator! Action has not been performed.'); return; }
	
	i = 0; booOkay = true;
	while (booOkay && i<arr.length) { booOkay = (arr[i][0] != '' && arr[i][1] != ''); i++; }
	if (booOkay == false) { alert('Row ' + i + ' contains at least one empty item! Action has not been performed.'); return; }

	/*
	i = 0; booOkay = true;
	while (booOkay && i<arr.length)
	{	booOkay = (F1.txtOut.value.indexOf(arr[i][1]) < 0); i++;
	} //while
	if (booOkay == false) { alert('The replacement item in row ' + i + ' does already exist in the output textbox! Action has not been performed.'); return; }
	*/

	sr = F1.txtOut.value;
	var reg = /x/;
 	for(i=0; i<arr.length; i++)
	{
		reg = eval('/' + arr[i][0].replace(/(\/|\.|\+|\*|\?|\^|\$|\||\\|\(|\)|\[|\]|\{|\})/g, "\\$1") + '/g'); // should contain a regular expression now
		sr = sr.replace(reg, arr[i][1]);
	} //for
	
	if (sr == F1.txtOut.value)
	{	alert('No matches found. Output has not been changed.'); } else
	{	F1.txtOut.value = sr; }
} //SearchReplace


//==========================================================================================


function DeleteCodeSpaces(s)
{
	s = s.replace(/\s+in\s+/g, 'in');
	s = s.replace(/(var|function|case|return|new|void|typeof|const|throw|else)[\s\n]+/g, '$1');
	s = s.replace(/\{/g, '{');
	s = s.replace(/[ \t]/g, '');
	s = s.replace(/\{/g, '{');
	return (s.replace(//g, ' '));
} //DeleteCodeSpaces


//==========================================================================================


function StripJSCode()
{	//F1.txtOut.disabled = false;
	F1.txtOut.value = '';

	var DeleteSpaceTabs = F1.chkSpaces.checked;
	var txt = F1.txtIn.value.replace(/^\s+|\s+$/g, '');
	txt = txt.replace(/\r\n/g, "\n");
	txt = txt.replace(/\r/g, "\n");
	
	var i = 0;
	var p = 0;
	var start = 0;
	var ch = '';
	var reg = /[\(\[=,]\s*$/; // find ( [ = or , at the end of the string (which can stand before a regular expression like /\n/)
	var relevant = false;
	var pos = txt.length;
	
	var arrCH = new Array('/*', '//', '/', '"', "'");

	while (pos > 0)
	{	start = 0;
		do
		{	for (i=0; i<arrCH.length; i++)
			{	p = txt.indexOf(arrCH[i], start);
				if (p >= 0 && p < pos) { pos = p; ch = arrCH[i]; } // find the next relevant character resp. character pair
//	alert('p  = ' + p + "\ni  = " + i + "\narrCH[" + i + '] = ' + arrCH[i] + "\npos  = " + pos + "\nch = " + ch);
			} //for
			
			if (ch == '/')
			{	p = txt.indexOf('/', 0);
//	alert(reg.test(txt.substring(0, p).replace(/\s/g, '') + '('));
				relevant = reg.test(txt.substring(0, p).replace(/\s/g, ''));
				relevant = reg.test(txt.substring(0, p));
				if (relevant)	{ pos = p; } else
								{ pos = txt.length; start = p + 1; }
//	relevant = eval(prompt('p=' + p, relevant));
				// If the string before the slash (slash itself and trailing spaces not included but cut)
				// ends with one of ([=, a regular expression has been found. Else the slash is a mathematical
				// operator or the code has a syntax error.
			} else { relevant = true; }
		} //do
		while(relevant == false);
		
		switch (ch) {
		//~~~~~~~~~~
		case '/*':
			p = txt.indexOf('*/', pos+2);
			if (DeleteSpaceTabs)
			{	F1.txtOut.value = F1.txtOut.value + DeleteCodeSpaces(txt.substr(0, pos)); } else
			{	F1.txtOut.value = F1.txtOut.value + txt.substr(0, pos); }
			txt = (p >= 0) ? txt.substr(p+2) : '';
			break;
		//~~~~~~~~~~
		case '//':
			p = txt.indexOf("\n", pos+2);
			if (DeleteSpaceTabs)
			{	F1.txtOut.value = F1.txtOut.value + DeleteCodeSpaces(txt.substr(0, pos)); } else
			{	F1.txtOut.value = F1.txtOut.value + txt.substr(0, pos) + "\n"; }
			txt = (p >= 0) ? txt.substr(p+1) : '';
			break;
		//~~~~~~~~~~
		case '/':
		case '"':
		case "'":
			p = pos;
			do { p = txt.indexOf(ch, p+1); } while (p > 0 && (txt.charAt(p-1) == "\\" && txt.charAt(p-2) != "\\"));
			if (DeleteSpaceTabs)
			{	F1.txtOut.value = (p > 0)	? F1.txtOut.value + DeleteCodeSpaces(txt.substr(0, pos)) + txt.substring(pos, p+1)
											: F1.txtOut.value + DeleteCodeSpaces(txt.substr(0, pos)) + txt.substring(pos); } else
			{	F1.txtOut.value = (p > 0) ? F1.txtOut.value + txt.substr(0, p+1) : F1.txtOut.value + txt; }
			txt = (p >= 0) ? txt.substr(p+1) : '';
			break;
		//~~~~~~~~~~
		default:
			if (DeleteSpaceTabs)
			{	F1.txtOut.value = F1.txtOut.value + DeleteCodeSpaces(txt.substr(0)); } else
			{	F1.txtOut.value = F1.txtOut.value + txt.substr(0); }
			txt = '';
			break;
		} //switch ch
		pos = txt.length;
	} //while pos>0
	txt = '';
	var d = new Date();
	F1.txtOut.value = F1.txtOut.value + "\n" + '//JavaScriptCodeStripper' + Version + ', ' + d.toLocaleString();
} //StripJSCode


/*
DeleteSpaceTabs	DST
DeleteCodeSpaces	DCS
relevant	rv
booOkay	boo
*/

/*
Change history:
---------------

V1.0:
	StripJSCode() was developed
	
V1.5:
	Design Changes:
	---------------
	Formular was enlarged
	Functions added (see below)
	
	Bugfix:
	-------
	StripJSCode()
	
	New:
	----
	SearchReplace()
	DeleteCodeSpaces()
	CalcBytes()
	ThousandsDots()
	DeleteEmptyRows()
	JoinRows()
	
V1.5.0.1:
	Code Optimizations:
	-------------------
	SearchReplace()
		starting conversions re-ordered
		check for empty string added
		changed reg to /[\(\[=,]\s*$/ and killed .replace() in test argument
		
	New:
	----
	Version var added
	
	Design Changes:
	---------------
	Formular
		"disabled" on Output deleted
		focus() added to button handlers
	StripJSCode()
		Date string changed to dynamic version
	
V1.5.0.2:
	Bug Fix:
	--------
	Every "else" which was not followed by a { was connected to the
	following string. Example: "else return 1" became "elsereturn 1".
*/